/**
 * @file
 * Initializes all Personified Message blocks.
 */

(function ($, Drupal, cookies) {
  Drupal.behaviors.personifiedMessage = {
    attach: function attach(context, settings) {
      function getQueryParams() {
        let result = {};
        let params = window.location.search.substring(1).split('&');
        for (let i = 0; i < params.length; i++) {
          let param = params[i].split('=');
          result[param[0]] = (param[1] === undefined) ? true : decodeURIComponent(param[1]);
        }
        return result;
      }
      if (typeof settings.personifiedMessage === 'undefined') {
        return;
      }
      let data = {
        query: getQueryParams(),
        cookie: cookies.get(),
        localstorage: localStorage,
      };
      $.each(settings.personifiedMessage, function (id, args) {
        let element = $('#' + id, context);
        if (element.length) {
          element.html(Drupal.jsonTemplate.plugins[args.transformer](args.template, data));
        }
      });
    },
  };
})(jQuery, Drupal, window.Cookies);
